import {
  __publicField
} from "../../chunk-T2T6Q22Z.js";
import { middlewareCreator } from "../../utils";
class ForceHTTPS {
  constructor(options = {}) {
    __publicField(this, "_options");
    this._options = {
      ignoredRoutes: [/^\/service\//],
      ...options
    };
  }
  getMiddleware() {
    return (req, res, next) => {
      if (!req.secure && req.get("X-Forwarded-Proto") !== "https" && !this._options.ignoredRoutes.some(
        (expression) => expression.test(req.originalUrl)
      )) {
        const host = req.get("Host");
        res.redirect(`https://${host}${req.url}`);
      } else {
        next();
      }
    };
  }
  get options() {
    return { ...this._options };
  }
}
const forceHTTPSMiddleware = middlewareCreator(
  (options = {}) => (app) => {
    const enabled = app.getConfig("forceHTTPS");
    if (!enabled)
      return void 0;
    return new ForceHTTPS(options).getMiddleware();
  }
);
export {
  ForceHTTPS,
  forceHTTPSMiddleware
};
//# sourceMappingURL=forceHTTPS.js.map