import "../../chunk-T2T6Q22Z.js";
import { provider, statuses as statusesFn } from "../../utils";
import { AppError } from "./appError";
class HTTPError extends AppError {
  constructor(message, status = statusesFn("ok"), context = {}, statuses = statusesFn) {
    super(message, { ...context, status }, statuses);
  }
}
const createHTTPError = (...args) => new HTTPError(...args);
const httpErrorProvider = provider((app) => {
  app.set("HTTPError", () => HTTPError);
  app.set("httpError", () => createHTTPError);
});
export {
  HTTPError,
  createHTTPError,
  httpErrorProvider
};
//# sourceMappingURL=httpError.js.map