import {
  __publicField
} from "../../chunk-T2T6Q22Z.js";
import fs from "fs/promises";
import { provider } from "../../utils";
class FrontendFs {
  constructor({ inject: { pathUtils } }) {
    __publicField(this, "_pathUtils");
    this._pathUtils = pathUtils;
  }
  delete(filepath) {
    return fs.unlink(this.getAppPath(filepath));
  }
  read(filepath, encoding = "utf-8") {
    return fs.readFile(this.getAppPath(filepath), encoding);
  }
  write(filepath, content) {
    return fs.writeFile(this.getAppPath(filepath), content);
  }
  getAppPath(filepath) {
    return this._pathUtils.joinFrom("app", filepath);
  }
}
const frontendFsProvider = provider((app) => {
  app.set(
    "frontendFs",
    () => new FrontendFs({
      inject: {
        pathUtils: app.get("pathUtils")
      }
    })
  );
});
export {
  FrontendFs,
  frontendFsProvider
};
//# sourceMappingURL=frontendFs.js.map