"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var appError_exports = {};
__export(appError_exports, {
  AppError: () => AppError,
  appErrorProvider: () => appErrorProvider,
  createAppError: () => createAppError
});
module.exports = __toCommonJS(appError_exports);
var import_utils = require("../../utils");
class AppError extends Error {
  constructor(message, context = {}, statuses = import_utils.statuses) {
    super(message);
    __publicField(this, "_date");
    __publicField(this, "_context");
    __publicField(this, "_statuses");
    this.name = this.constructor.name;
    this._date = new Date();
    this._statuses = statuses;
    this._context = this._parseContext(context);
    if (Error.captureStackTrace) {
      Error.captureStackTrace(this, this.constructor);
    }
  }
  getResponse() {
    return this.response;
  }
  get response() {
    return this._context.response || {};
  }
  get status() {
    return this._context.status;
  }
  get context() {
    return this._context;
  }
  get date() {
    return this._date;
  }
  _parseContext(context) {
    const result = { ...context };
    if (result.status && typeof result.status === "string") {
      result.status = this._statuses.code[result.status.toLowerCase()] || result.status;
    }
    return result;
  }
}
const createAppError = (...args) => new AppError(...args);
const appErrorProvider = (0, import_utils.provider)((app) => {
  app.set("AppError", () => AppError);
  app.set("appError", () => createAppError);
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AppError,
  appErrorProvider,
  createAppError
});
//# sourceMappingURL=appError.js.map