"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var apiClient_exports = {};
__export(apiClient_exports, {
  APIClient: () => APIClient,
  apiClientProvider: () => apiClientProvider
});
module.exports = __toCommonJS(apiClient_exports);
var import_api_utils = require("@homer0/api-utils");
var import_deep_assign = require("@homer0/deep-assign");
var import_utils = require("../../utils");
class APIClient extends import_api_utils.APIClient {
  constructor({ inject: { http, HTTPError }, ...rest }) {
    const { endpoints, gateway, url } = rest;
    const useEndpoints = endpoints || gateway;
    const apiConfig = {
      url,
      endpoints: useEndpoints
    };
    super({
      ...apiConfig,
      fetchClient: http.fetch
    });
    __publicField(this, "_http");
    __publicField(this, "_HTTPError");
    __publicField(this, "_apiConfig");
    this._http = http;
    this._HTTPError = HTTPError;
    this._apiConfig = (0, import_deep_assign.deepAssignWithOverwrite)({}, apiConfig);
  }
  get apiConfig() {
    return (0, import_deep_assign.deepAssignWithOverwrite)({}, this._apiConfig);
  }
  _getErrorMessageFromResponse(response) {
    const res = response;
    if (res.error)
      return res.error;
    if (res.data) {
      if (res.data.message)
        return res.data.message;
      if (res.data.error)
        return res.data.error;
    }
    return "Unexpected error";
  }
  formatError(response, status) {
    return new this._HTTPError(this._getErrorMessageFromResponse(response), status);
  }
}
const apiClientProvider = (0, import_utils.providerCreator)(
  (options = {}) => (app) => {
    const defaultName = "apiClient";
    const { serviceName = defaultName, clientClass: ClientClass = APIClient } = options;
    let { configSetting } = options;
    if (!configSetting) {
      configSetting = serviceName === defaultName ? "api" : serviceName;
    }
    app.set(
      serviceName,
      () => new ClientClass({
        inject: {
          http: app.get("http"),
          HTTPError: app.get("HTTPError")
        },
        ...app.getConfig(configSetting)
      })
    );
  }
);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  APIClient,
  apiClientProvider
});
//# sourceMappingURL=apiClient.js.map